{$A+,B-,D+,E+,F-,G+,I-,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M $800,0,$10000 }   { 2K stack, 64K Heap }
Uses Dos;

{
 Copyright 1998 by Eugeni Bobrov <eeb@get2net.dk>
 Assisted by Hans Schou <chlor@schou.dk>

 Licens: GPL ver. 2.0
}

{$DEFINE Only512}

Type
  ZeroArray = Array[0..0]  Of Byte;
  RegRecord = Record
    rAX, rBX, rCX, rDX : Word;
    rSI, rDI, rBP, rSP : Word;
    rDS, rES, rSS, rCS : Word;
    RetAX, Flags       : Word;
    cCS, cIP           : Word;
  End;
  Str4	    = String[4];
  Str2	    = String[2];
  L         = Record
    Ofs, Seg : Word;
  End;

Const
  Dir : DirStr = '';
  Name : NameStr = '';
  Ext : ExtStr = '';
  SizeOfR = SizeOf(RegRecord);

var
  Int13Vec : Procedure;
  Arg1, Arg2 : String[10];
  Reg_i, J, n : Word;
  F : File;
  TF : Text;
  R : RegRecord;
  Buf : ^ZeroArray;
  CommandLine : ^String;

Function HexWord(w: Word) : Str4;
Const hexChars: Array [0..$F] of Char = '0123456789ABCDEF';
Begin
  HexWord := hexChars[Hi(w) shr 4] + hexChars[Hi(w) and $F]
    + hexChars[Lo(w) shr 4] + hexChars[Lo(w) and $F];
End;

Function HexByte(B: Byte) : Str2;
Const hexChars: Array [0..$F] of Char = '0123456789ABCDEF';
Begin
  HexByte := hexChars[B shr 4] + hexChars[B and $F];
End;

{$F+}
Procedure NewInt13; Interrupt; Assembler;
Asm
        CMP	Reg_i, 65000
        JA      @Out
	MOV	AX,	[BP+10h]               { TP destroys AX when entering }
	CMP	DL, 	1
	JA	@Out
	MOV	R.rAX,	AX                     { Save Registers }
	MOV	R.rBX,  BX
	MOV	R.rCX,  CX
	MOV	R.rDX,  DX
	MOV	R.rSI,  SI
	MOV	R.rDI,  DI
	MOV	R.rBP,  BP
	MOV	R.rSP,  SP
	MOV	R.rDS,  DS
	MOV	R.rES,  ES
	MOV	R.rSS,  SS
	MOV	R.rCS,  CS
	MOV	AX,     [BP+14h]               { Callers CS }
	MOV	R.cCS,  AX
	MOV	AX,     [BP+12h]               { Callers IP }
	MOV	R.cIP,  AX
	MOV	AX,	[BP+10h]               { TP destroys AX when entering }

	PUSHF
	CALL	DWORD PTR Int13Vec             { CALL INT 13 }
	MOV	[BP+10h], AX                   { Return code from INT 13}
	MOV	R.RetAx,  AX                   { Save AX Return Code }
	PUSH	AX
	PUSHF
	POP	AX
	MOV	R.Flags,AX                     { Save Flags }
	POP	AX

	CLD				       { Copy Registers R to }
	MOV	SI, OFFSET R		       { Buf^ }
	LES	DI, Buf
	ADD	DI, Reg_i
	MOV	CX, SizeOfR
	SHR	CX, 1
	REP	MOVSW
	ADD	Reg_i, SizeOfR

        PUSHA
	MOV	AX, R.rAX
	CMP	AH, 2
	JB	@Out2
	CMP	AH, 3
	JA	@Out2
	MOV     CL, AL
        XOR     CH, CH
        OR	CX, CX
	JZ	@Out2

{$IFDEF Only512}
        MOV     CL, 1
{$ENDIF}
	SHL	CX, 9
	ADD	Reg_I, CX

	MOV	SI, R.rBX
        SHR     CX, 1
        MOV	BX, R.rES
	PUSH	BX
	POP	DS
	REP	MOVSW
@Out2:
        POPA
        JMP	@Out1
@Out:
	PUSHF
	CALL	DWORD PTR Int13Vec             { CALL INT 13 }
	MOV	[BP+10h], AX                   { Return code from INT 13}

@Out1:
End;
{$F-}

Procedure WriteStatus;
Var
  s : String;
  T : Word;
Begin
  With R Do Begin
    Write(TF, 'Int 13 Call ', n,' Drive', Lo(rDX):4);
    Case Hi(rAX) Of
	2 : s := 'Read   ';
	3 : s := 'Write  ';
	5 : s := 'Format ';
      $16 : s := 'Change Line Status ';
    Else
      s := '';
    End;
    If Hi(rAX) In [2,3,5, $16] Then Begin
      Write(TF, '  ', s);
      If Hi(rAX) < $16 Then Begin
	T := Hi(rCX)+(Lo(rCX) Shr 6) Shl 8;
	Write(TF,   Lo(rAX):2, ' Sector(s), Track ',T:4, ' Head' , Hi(rDX):3);
	Write(TF, ' Sector', (rCX And $3F):3);
      End;
    End;
    WriteLn(TF);
    if (Hi(rAX) in [2,3]) and (T=0) and (Hi(rDX)=0) and (rCX And $3F = 1) then
      WriteLn( TF, 'This is the bootrecord' );
    if (Hi(rAX) = $16) then
      case Hi(RetAX) of
        $00 : WriteLn( TF, 'No errors and disk in drive (Change line in-active)' );
        $01 : WriteLn( TF, 'Invalid diskette parameters' );
        $06 : WriteLn( TF, 'if this is a normal floppy: "No disk in drive" (Change line active)');
        $80 : WriteLn( TF, 'Drive not ready' );
      end;
  End;
End;

Procedure WriteRegisters;
Begin
  WriteLn(TF, 'Called From ', HexWord(R.cCS), ':', HexWord(R.cIP));
  Write  (TF, 'AX    ', HexWord(R.rAX), '  ');
  Write  (TF, 'BX    ', HexWord(R.rBX), '  ');
  Write  (TF, 'CX    ', HexWord(R.rCX), '  ');
  WriteLn(TF, 'DX    ', HexWord(R.rDX));
  Write  (TF, 'SI    ', HexWord(R.rSI), '  ');
  Write  (TF, 'DI    ', HexWord(R.rDI), '  ');
  Write  (TF, 'BP    ', HexWord(R.rBP), '  ');
  WriteLn(TF, 'SP    ', HexWord(R.rSP));
  Write  (TF, 'DS    ', HexWord(R.rDS), '  ');
  Write  (TF, 'ES    ', HexWord(R.rES), '  ');
  Write  (TF, 'SS    ', HexWord(R.rSS), '  ');
  WriteLn(TF, 'CS    ', HexWord(R.rCS));
  Write  (TF, 'RetAX ', HexWord(R.RetAx), '  ');
  WriteLn(TF, 'Flags ', HexWord(R.Flags));
  WriteLn(TF);
End;


Procedure DumpData(Index, Count: Word);
  Procedure AsASCII( Idx:Word );
   var i : Integer;
  begin
    Write( TF, '   ' );
    For i := 0 to Pred(16) do
      if Buf^[i+Idx] in [32..127] then
        Write( TF, Chr(Buf^[i+Idx]) )
      else
        Write( TF, '.' );
  end;

Var i : Word;
Begin
  For i := 0 To Pred(Count) Do Begin
    If i Mod 16 = 0 Then
      Write(TF, Hexword(i), ': ');
    Write(TF, HexByte(Buf^[i+Index]));
    If (i Mod 16 = 15) Then begin
      AsASCII(i+Index-15);
      WriteLn(TF);
    end Else
      If i Mod 8 = 7 Then
        Write(TF, '-')
      Else
        Write(TF, ' ');
  End;
  WriteLn(TF, #13#10);
  Write('.');
End;

Var
  S : String;
Begin
  WriteLn('Interrupt 13h logger');
  WriteLn('Copyright 1998 Eugeni Bobrov');
  WriteLn('Licens: GPL ver. 2.0');
  WriteLn;
  if ParamCount = 0 then begin
    WriteLn('Usage:');
    WriteLn(' LOGINT13 <dos command>');
    WriteLn;
    WriteLn('Example:');
    WriteLn(' LOGINT13 DIR A:\');
    Halt;
  end;
  Reg_i := 0;
  J := 0;
  CommandLine := Ptr(PrefixSeg,$80);
  GetIntVec($13, @Int13Vec);
  SetIntVec($13, Addr(NewInt13));
  GetMem(Buf,  65520 );
  FillChar(Buf^, 65520, 0);
  SwapVectors;
  Exec(GetEnv('COMSPEC'),' /C ' + CommandLine^);
  SwapVectors;
  SetIntVec($13,@Int13Vec);
  j := 0;
  WriteLn('Reg_i ', Reg_i);

  Assign(TF, 'INT13.LOG');
  ReWrite(TF);
  WriteLn(TF, 'Executed Command: ' ,CommandLine^, #13#10 );
{  WriteLn(TF, Reg_i Div SizeOf(R), ' Int 13 Calls made');}
  Repeat
    Move(Buf^[J], R, SizeOf(R));
    WriteStatus;
    WriteRegisters;
    Inc(J, SizeOf(R));

    If (Hi(R.rAX) In [2,3]) And (Lo(R.rAX)>0) Then Begin
{$IFDEF Only512}
      DumpData(J, 512);
      Inc(J, 512);
{$ELSE}
      DumpData(J, Lo(R.rAX)*512);
      Inc(J, Lo(R.rAX) * 512);
{$ENDIF}
    End;
  Until j >= Reg_i;
  Close(TF);
end.
